// Generated by Visual Programming Armoury


/**
 * @(#)HtmlPanel.java	1.14 98/08/26
 * 
 * Copyright 1997, 1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 * 
 * 
 * @version 1.14 98/08/26
 * @author Jeff Dinkins
 * @author Tim Prinzing
 * @author Peter Korn (accessibility support)
 */
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.border.*;
public  class HtmlViewer1 implements HyperlinkListener
{
	public JFrame frame  ;
	
	public JPanel panRoot  ;
	
	public JScrollPane panScroll  ;
	
	public JEditorPane panViewer  ;
	
	public static void main (String [] args) 
	{
		try {
			UIManager.setLookAndFeel(
				UIManager.getCrossPlatformLookAndFeelClassName());
		} catch (Exception e) { }
		
		// create and show the GUI
		new HtmlViewer1();
	}
	
	public HtmlViewer1 () 
	{
		panRoot = new JPanel();
		panRoot.setPreferredSize(new Dimension(400, 300));
		panRoot.setBorder(new EmptyBorder(5, 5, 5, 5));
		panRoot.setLayout(new BorderLayout());
		
		// create the top-level container
		frame = new JFrame("HTML Viewer");
		frame.getContentPane().setLayout(new BorderLayout());
		frame.getContentPane().add(panRoot, BorderLayout.CENTER);
		
		try {
			String fileName = "file:" + System.getProperty("user.dir") + File.separator + "example.html";
		
			panViewer = new JEditorPane(fileName);
			panViewer.setEditable(false);
			panViewer.addHyperlinkListener(this);
		
			panScroll = new JScrollPane();
			panScroll.setBorder(new SoftBevelBorder(BevelBorder.LOWERED));
			panScroll.setPreferredSize(new Dimension(400, 300));
		
			JViewport vp = panScroll.getViewport();
			vp.add(panViewer);
			vp.setBackingStoreEnabled(true);
			panRoot.add(panScroll, BorderLayout.CENTER);
		}
		catch (IOException e) {
			System.out.println("IOException: " + e);
		}
		
		frame.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}
		});
		
		frame.pack();
		frame.show();
	}
	
	
	/**
	 * Notification of a change relative to a 
	 * hyperlink.
	 */
	public void hyperlinkUpdate (HyperlinkEvent e) 
	{
		if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
			linkActivated(e.getURL());
		}
	}
	
	
	/**
	 * Follows the reference in an
	 * link.  The given url is the requested reference.
	 * By default this calls <a href="#setPage">setPage</a>,
	 * and if an exception is thrown the original previous
	 * document is restored and a beep sounded.  If an 
	 * attempt was made to follow a link, but it represented
	 * a malformed url, this method will be called with a
	 * null argument.
	 * 
	 * @param u the URL to follow
	 */
	protected void linkActivated (URL u) 
	{
		Cursor c = panViewer.getCursor();
		Cursor waitCursor = Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR);
		panViewer.setCursor(waitCursor);
		SwingUtilities.invokeLater(new PageLoader(u, c));
	}
	
	
	/**
	 * temporary class that loads synchronously (although
	 * later than the request so that a cursor change
	 * can be done).
	 */
	 class PageLoader implements Runnable
	{
		 URL url  ;
		
		 Cursor cursor  ;
		
		 PageLoader (URL u, Cursor c) 
		{
			url = u;
			cursor = c;
		}
		
		public void run () 
		{
			if (url == null) {
				// restore the original cursor
				panViewer.setCursor(cursor);
			
				Container parent = panViewer.getParent();
				parent.repaint();
			}
			else {
				Document doc = panViewer.getDocument();
				try {
					panViewer.setPage(url);
				}
				catch (IOException e) {
					panViewer.setDocument(doc);
					panViewer.getToolkit().beep();
				}
				finally {
					// schedule the cursor to revert after the paint has happended.
					url = null;
					SwingUtilities.invokeLater(this);
				}
			}
		}
		
		
	}
	
}
