#ifndef _INC_DATASERV_HPP
#define _INC_DATASERV_HPP
class TC_CPsDataDriver;
class PsDrvBind;

// **********************************************************************
class TC_PS_EXPORT TC_CPsDataDriver 
{
friend class TC_CPsDataService;
private:  PsDrvBind * m_DrvBind ;
private:  char * m_DrvName ;
private:  TCPsRetCode LoadDriver ()  ;
public:   TC_CPsDataDriver (const char * drv_name)  ;
public:   ~TC_CPsDataDriver ()  ;
public:  TCPsRetCode Connect (const char * srv, const char * db, const char * usr, const char * pwd) TC_PS_THROW_FUNC ;
public:  BOOL IsConnected ()  ;
public:  TCPsRetCode Disconnect ()  ;
public:  TCPsRetCode Execute (const char * sql_stmt) TC_PS_THROW_FUNC ;
public:  PsDrvBind * GetDrvBind ()  ;

}; // end of class TC_CPsDataDriver

// **********************************************************************

// **********************************************************************
class TC_PS_EXPORT TC_CPsDataService 
{
private:  TC_CPsDataDriver * m_DataDriver ;
private:  TC_TNameNode <TC_CPsDataService> m_Node ;
private:  static  TC_TNameList <TC_CPsDataService> m_Chain ;
public:  const char * GetName ()  ;
public:  TC_CPsDataDriver * GetDataDriver ()  ;
public:   TC_CPsDataService (const char * name, TC_CPsDataDriver * drv)  ;
public:   ~TC_CPsDataService ()  ;
public: static TCPsRetCode Register (TC_CPsDataService * ds) TC_PS_THROW_FUNC ;
public: static TC_CPsDataService * UnRegister (const char * name, BOOL del = FALSE)  ;
public: static TC_CPsDataService * GetService (const char * name)  ;

}; // end of class TC_CPsDataService

// **********************************************************************

#endif // _INC_DATASERV_HPP
