#ifndef _INC_TCCOREEX_HPP
#define _INC_TCCOREEX_HPP
#ifdef TC_COREEX_DLL
	#define TC_COREEX_EXPORT	__declspec(dllexport)
#else
	#define TC_COREEX_EXPORT	__declspec(dllimport)
#endif
#define	TC_DT_UNDEF		0
#define	TC_DT_SHORT		1
#define	TC_DT_USHORT	2
#define	TC_DT_LONG		3
#define	TC_DT_ULONG		4
#define	TC_DT_FLOAT		5
#define	TC_DT_DOUBLE	6
#define	TC_DT_BOOL		7
#define	TC_DT_BYTE		8
#define	TC_DT_CHARARR	9
#define	TC_DT_STRING	10
#define	TC_DT_DATE		11
#define	TC_DT_TIME		12
#define	TC_DT_BCD		13
#define TC_DT_BINARR	14
#define	TC_DT_LAST_TYPE	14
#define TC_SCALE_FLOAT		3
#define TC_SCALE_DOUBLE		6
enum TCRWPrivilege {
 R_Privilege,
 W_Privilege,
};
enum TCRWRequest {
 R_Request,
 W_Request,
};
class TC_CRWAccess;
#define TC_COREEX_ASSERT assert
typedef int (*TCCmpFunc)(const void*, const void*);
enum TCCmpResult {
 cmp_Equal = 0,
 cmp_Greater = 1,
 cmp_Less = -1,
};
#define TC_HEAPCHECK {\
 int heapstatus = _heapchk();\
   switch( heapstatus )\
   {\
  case _HEAPOK:\
      winout("HEAP: OK - heap is fine" );\
      break; \
   case _HEAPEMPTY:\
      winout("HEAP: OK - heap is empty" );\
      break;\
   case _HEAPBADBEGIN:\
      winout( "HEAP: ERROR - bad start of heap" );\
      break;\
   case _HEAPBADNODE:\
      winout( "HEAP: ERROR - bad node in heap" );\
      break;\
   }\
}
#define TC_STR_NULL	"NULL"

// **********************************************************************
 template <class BaseType>
class TC_TCoreOper 
{
public: static BaseType NullValue () 
{
return BaseType ();
} // end of func
// **********************************************************************

public: static int Compare (const BaseType& o1, const BaseType& o2) 
{
return o1.Compare (o2);
} // end of func
// **********************************************************************

public: static void Destroy (void* p) 
{
if (p) delete (BaseType*) p;
} // end of func
// **********************************************************************

public: static void* MakeCopy (const BaseType& o) 
{
return  (void*) new BaseType (o);
} // end of func
// **********************************************************************

public: static void* MakePointer (const BaseType& o) 
{
return  (void*) &o;
} // end of func
// **********************************************************************

public: static BaseType& Deref (const void*& p) 
{
return *(BaseType*&) p;
} // end of func
// **********************************************************************

public: static void DoDestroy (const BaseType&) 
{
 
} // end of func
// **********************************************************************


}; // end of class TC_TCoreOper

// **********************************************************************

// **********************************************************************
class TC_COREEX_EXPORT TC_CComparator 
{
public: virtual  ~TC_CComparator () 
{
 
} // end of func
// **********************************************************************

public: virtual int operator() (void * p1, void * p2) const =0 ;

}; // end of class TC_CComparator

// **********************************************************************

// **********************************************************************
 template <class Base>
class TC_TComparator 
	: public TC_CComparator
{
public:   ~TC_TComparator () 
{
} // end of func
// **********************************************************************

public:  int operator() (void* p1, void* p2) const
{
if (p1 && p2) {
	const Base& r1 = TC_TCoreOper<Base>::Deref (p1);
	const Base& r2 = TC_TCoreOper<Base>::Deref (p2);
	return  TC_TCoreOper<Base>::Compare (r1, r2);
}
return p1 < p2 ? -1 : (p1 == p2 ? 0 : 1);
} // end of func
// **********************************************************************


}; // end of class TC_TComparator

// **********************************************************************

// **********************************************************************
 template <class T>
class TC_TIterator 
{
public:   ~TC_TIterator () 
{
 
} // end of func
// **********************************************************************

public: virtual void Reset ()  =0 ;
public: virtual BOOL More ()  =0 ;
public: virtual T * Next ()  =0 ;

}; // end of class TC_TIterator

// **********************************************************************
#include <String.hpp>
#include <Array.hpp>

#include <exceptn.hpp>
#include <cltn.hpp>
#include <fmtparse.hpp>
#include <datetime.hpp>
#include <bcd.hpp>
#include <buffer.hpp>
#include <thread.hpp>
#include <blob.hpp>
#include <frmiface.hpp>

#endif // _INC_TCCOREEX_HPP
