#define RPRT_MAGIC_FILE_HEADER	"RP02"

#define RP_FONT_SIZES { 6,7,8,9,10,11,12,14,16,18,20,22,24,26,28,36,48,72,-1 }

struct PaperSizeStruct
{
	char * name;
	int _mm_cx, _mm_cy;
	int w_type;
};
struct _RprtItemFlags
{
	TCRPFIELD f;

	unsigned	draw_dsgn	: 8;
	unsigned	fontIndex	: 8;
	unsigned	fontSzIdx	: 8;
	unsigned	fontAttr	: 8;
};
struct _RprtRowFlags
{
	TCRPROW  f;
};

struct _RprtPictFlags
{
	unsigned	x	: 16;
	unsigned	ly	: 16;
//1
	unsigned	cx	: 16;
	unsigned	cy	: 16;
//2
	unsigned	line		: 16;
	unsigned	stretch		: 2;
	unsigned	u_dummy1	: 14;
//3
	long	dw_dummy3;
//4
	long	dw_dummy4;
//5
	long	dw_dummy5;
//6
	long	dw_dummy6;
//7
	long	dw_dummy7;
//8
};

struct PageStruct
{
	DWORD	type;

	RECT	indent;

	unsigned	orient		: 1;
	unsigned	bi_dummy1	: 31;

	DWORD	dw_dummy1;
	DWORD	dw_dummy2;
};
struct _RprtSectionFlags
{
	short	w_x;
	short	w_y;
	short	w_cx;
	short	w_cy;
	short	w_ix;
	short	w_iy;

	unsigned	w_flg		: 16;
	unsigned	w_dummy1	: 16;

	unsigned	keep_all	: 1;
	unsigned	keep_det	: 1;
	unsigned	keep_ftr	: 1;
	unsigned	u_dummy1	: 29;


	DWORD	dw_dummy[3];
};
struct TcRp2CreateStruct
{
	DWORD	proc;
	DWORD	user;

	DWORD	work_type;	// 0-Preview, 1-Print
	HWND	hwnd;
	DWORD	design;

	char file_name[1];
};

struct TcRp2SetImageStruct
{
	char name [ 32 ];
	char * data;
};
typedef DWORD (* TCRP2_PROC)(DWORD obj,DWORD cmd,DWORD arg);

enum
{
	TcRp2M_NONE,			//
	TcRp2M_CREATE,			// TcRp2CreateStruct* ; Return Dll_Object
	TcRp2M_DESTROY,			//

	TcRp2M_VIEW_PAGE,		// int page_num; Return CurPage
	TcRp2M_SET_VAR,			// char [] = "VarName\0VarValue\0"
	TcRp2M_SET_IMG,			// TcRp2SetImageStruct *

	TcRp2M_PRINT,			// return hWnd_Print_Dlg
	TcRp2M_GET_PAINT,		// TcRp1PaintStruct
	TcRp2M_GET_IMGSIZE,		// char *name; Return MAKELONG(cx,cy)
};

enum
{
	TcRp2E_NONE,			//

	TcRp2E_EXECUTE,			// char * name
	TcRp2E_FETCHNEXT,		// char * name
	TcRp2E_PAINT_BEGIN,		// TcRp1PaintStruct
	TcRp2E_PAINT_END,		// TcRp1PaintStruct

	TcRp2E_SET_BITMAP,		// (Preview mode) HBITMAP
	TcRp2E_DRAW_BITMAP,		// (Preview mode) 

	TcRp2E_PRINT_DONE,		// (Print mode) 1-break, 2-error
	TcRp2E_PRINT_WAIT,		// (Print mode) BOOL wait

	TcRp2E_THREAD_ENTER,
	TcRp2E_THREAD_EXIT,
};
//////////////////////////////////////////////////

