#ifndef _INC_TCWINEXT_HPP
#define _INC_TCWINEXT_HPP
#ifdef BUILD_TCWINAPPLIB
#define TCWINAPPLIB __declspec(dllexport)
#else
#ifdef BUILD_LOCAL
#define TCWINAPPLIB
#else
#define TCWINAPPLIB __declspec(dllimport)
#endif
#endif

#include <TcWinApp.hpp>
#include <RegExp.hpp>
enum
{
	WCT_TcTree = 50,
	WCT_TcTable,
};
 extern  TCWINAPPLIB char gszCls_TcTreeView [];
 extern  TCWINAPPLIB char gszCls_TcTbl [];
 extern  TCWINAPPLIB char gszCls_TcGraph [];
 extern  TCWINAPPLIB char gszCls_TcFormEditor [];
 extern  TCWINAPPLIB char gszCls_TcEdit [];
TCWINAPPLIB void tcTbl_ToRegistry (TC_CWindow *tbl)  ;
TCWINAPPLIB void _tcTbl_ToRegistry (TC_CWindow *tbl, LPCSTR path, LPCSTR vname)  ;
TCWINAPPLIB void tcTbl_FromRegistry (TC_CWindow *tbl)  ;
TCWINAPPLIB void _tcTbl_FromRegistry (TC_CWindow *tbl, LPCSTR path, LPCSTR vname)  ;
TCWINAPPLIB BOOL tcEditFrmtEv_Paint (TC_Event *e)  ;
TCWINAPPLIB BOOL tcEditFrmtEv_Focus (TC_Event *e)  ;

// **********************************************************************
class TCWINAPPLIB TC_CRTDesigner 
	: public TC_CWindow
{
public:

struct _AWinRTESet
{
	short id;
	short dummy1;

	short x;
	short y;

	short cx;
	short cy;

	COLORREF color[2];	// text, back

	short	font_size;
	short	font_attr;
	char	font_name [ LF_FACESIZE ];

	unsigned	g_l : 8;
	unsigned	g_t : 8;
	unsigned	g_r : 8;
	unsigned	g_b : 8;
};
public:  TC_CWindow * p_Area ;
public:  HWND hFE ;
public:  TCArrayHWND arrHCtrl ;
public:  TCArrayULONG arrHFE ;
public:  UINT hRoot ;
public:  TCArrayRECT arrGROW ;
public:  TC_CArrayString asFont ;
public:  TC_CString frameTitle ;
public:  TC_CString areaWName ;
public:  static  char* asz_BtnName [];
public: static BOOL CALLBACK Fill_ECProc (HWND hwnd, LPARAM lParam)  ;
public:  BOOL Form_Creator (TC_CWindow *frame)  ;
public: TC_CWindow * mc_AlgnL;
public: TC_CWindow * mc_AlgnR;
public: TC_CWindow * mc_GrL;
public: TC_CWindow * mc_GrT;
public: TC_CWindow * mc_GrR;
public: TC_CWindow * mc_GrB;
public: TC_CWindow * mc_X;
public: TC_CWindow * mc_Y;
public: TC_CWindow * mc_CX;
public: TC_CWindow * mc_CY;
public: TC_CWindow * mc_Font;
public: TC_CWindow * mc_List;
public: TC_CWindow * mc_FE;
public:  void Init ()  ;
public:  BOOL Ev_Font (TC_Event*)  ;
public:  BOOL Ev_Wm_Cmd (TC_Event_WM *e)  ;
public:  BOOL Ev_Notify (TC_Event_NM *e)  ;
public:  BOOL Ev_ListCmd (TC_Event_CM *e)  ;
public:  BOOL Ev_GrChg (TC_Event_CM *e)  ;
public:  BOOL Ev_PosChg (TC_Event_CM *e)  ;
public:  BOOL Cmd_Align (TC_Event_CM *e)  ;
public:  void Done ()  ;
public:  void Update_Info ()  ;
public: virtual void* GetInterface (LPCSTR name)  ;
public: virtual const char* GetClassName ()  ;
public: static BOOL Run (TC_CWindow *area, LPCSTR win_name, LPCSTR title=0)  ;
public: static BOOL ReadReg (TC_CWindow *area, LPCSTR win_name)  ;

}; // end of class TC_CRTDesigner

// **********************************************************************
TCWINAPPLIB BOOL tcDDEv_TcTreeCanDD (TC_Event_NM *e)  ;
TCWINAPPLIB void tcDDUse_TcTree (TC_CWindow *win)  ;

// **********************************************************************
class TCWINAPPLIB TC_CTblFind 
	: public TC_CWindow
{
public:  HWND hwndTbl ;
public:  int n_Method ;
public:  int n_OnlyWord ;
public:  int n_MatchCase ;
public:  int n_Where ;
public:  int n_Back ;
public:  int lb_Off ;
public:  TC_CArrayString asTitles ;
public:  TCArrayINT aiIdx ;
public:  TCArrayCHAR acC ;
public:  TC_CString s_Text ;
public:  TC_CArrayString savStrings ;
public:  TC_CRegExp m_RegExp ;
public: virtual void* GetInterface (LPCSTR name)  ;
public: virtual const char* GetClassName ()  ;
public:  void Init1 ()  ;
public:  void Init ()  ;
public:  void Read_Registry ()  ;
public:  BOOL Ev_Wm_Destroy (TC_Event *)  ;
public:  int Count ()  ;
public:  BOOL Ev_DrawItem (TC_Event_WIN *e)  ;
public:  BOOL Ev_Cmd (TC_Event_WM *e)  ;
public:  BOOL Ev_DblClick (TC_Event *)  ;
public:  BOOL Ev_LBMouse (TC_Event_WM *e)  ;
public:  BOOL Ev_LbSpc (TC_Event *)  ;
public:  BOOL Check_EnableOK ()  ;
public:  void Work ()  ;
public:  void _Add2CbList ()  ;
public:  BOOL Check1Cell (int row, int col)  ;
public:  BOOL Ev_AddAll (TC_Event *)  ;
public:  BOOL Ev_ClrAll (TC_Event *)  ;
public:  void Enable_Area (BOOL enbl)  ;
public: static int Mouse2LbRow (HWND hLB, int y_ms)  ;
public:  int _Run ()  ;
public: TC_CWindow * mc_Text;
public: TC_CWindow * mc_RegExp;
public: TC_CWindow * mc_Where;
public: TC_CWindow * mc_MatchCase;
public: TC_CWindow * mc_OnlyWord;
public: TC_CWindow * mc_Back;
public: TC_CWindow * mc_List;
public: TC_CWindow * mc_OK;
public: static void Run (HWND hwnd_tbl)  ;

}; // end of class TC_CTblFind

// **********************************************************************

#endif // _INC_TCWINEXT_HPP
